/* 2011.8.26
****************************************
**  Copyright  (C)        1999-2011   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/

/*
********************************************** 
**
**  ʼCH438 3 
**
**********************************************
*/


#include"include.h"

/*
  ĬϵⲿʱƵ22.1184MHZ
*/
#define CH438UART3_BPS  9600            /* CH4383ͨѶ */
#define Fpclk           44236800         /* ڲʱƵ    */


/*********************************************************************************************************
** : InitCH438UART3
** : ãڳʼCH4383
** 䡡: 
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/

void InitCH438UART3( void )       
{
    UINT16 div;
    UINT8 DLL, DLM;
/**************************************************************************
          CH4383ļĴ
**************************************************************************/
//    UART3_Reset();
    div = ( Fpclk >> 4 ) / CH438UART3_BPS;
    DLM = div >> 8;
    DLL = div & 0xff;
    WriteCH438Data( REG_LCR3_ADDR, BIT_LCR_DLAB );    /* DLABΪ1 */
    WriteCH438Data( REG_DLL3_ADDR, DLL );             /* ò */
    WriteCH438Data( REG_DLM3_ADDR, DLM );
		
    WriteCH438Data( REG_FCR3_ADDR, /*BIT_FCR_RECVTG1 |*/ BIT_FCR_RECVTG0 | BIT_FCR_FIFOEN );    /* FIFOģʽΪ112ֽ */

    WriteCH438Data( REG_LCR3_ADDR, BIT_LCR_WORDSZ1 | BIT_LCR_WORDSZ0 );                     /* ֳ8λ1λֹͣλУ */

    WriteCH438Data( REG_IER3_ADDR, BIT_IER1_CK2X|BIT_IER_IEMODEM | BIT_IER_IELINES | BIT_IER_IETHRE | BIT_IER_IERECV );    /* ʹж */

    WriteCH438Data( REG_MCR3_ADDR, BIT_MCR_OUT2    | BIT_MCR_RTS     | BIT_MCR_DTR );              /* ж,DTR,RTSΪ1 */

//    WriteCH438Data(REG_FCR3_ADDR,ReadCH438Data(REG_FCR3_ADDR)| BIT_FCR_TFIFORST|BIT_FCR_RFIFORST);

}



/*********************************************************************************************************
** : UART3_Reset
** : ܺڸλCH4383, λ֮Ҫ³ʼ ſʹ
** 䡡: 
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void CH438_UART3_Reset( void )
{

    WriteCH438Data( REG_IER3_ADDR, BIT_IER_RESET ); 

}




/*********************************************************************************************************
** : UART3_LowPower
** : ܺCH4383͹ģʽ
** 䡡: 
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void CH438_UART3_LowPower( void )
{

    WriteCH438Data( REG_IER3_ADDR, BIT_IER_LOWPOWER ); 

}




/*********************************************************************************************************
** : UART3_SendByte
** : ܺCH4383 ͵ֽ
** 䡡: 
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void CH438_UART3_SendByte( UINT8 dat )    
{

    while( ( ReadCH438Data( REG_LSR3_ADDR ) & BIT_LSR_THRE ) == 0 );    /* ȴݷ */

    WriteCH438Data( REG_THR3_ADDR, dat );
}




/*********************************************************************************************************
** : UART3_RcvByte
** : ܺCH4383 յֽ
** 䡡: 
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
UINT8 CH438_UART3_RcvByte( void )    
{

    UINT8 Rcvdat;

    if( !( ReadCH438Data( REG_LSR3_ADDR ) & ( BIT_LSR_BREAKINT | BIT_LSR_FRAMEERR | BIT_LSR_PARERR | BIT_LSR_OVERR ) ) )    /*  b1-b4޴ */
    {

        while( ( ReadCH438Data( REG_LSR3_ADDR ) & BIT_LSR_DATARDY ) == 0 );    /* ȴ׼ */

        Rcvdat = ReadCH438Data( REG_RBR3_ADDR );    /* ӽջĴ */

        return( Rcvdat );
    }

    else ReadCH438Data( REG_RBR3_ADDR );    /* д */

}





/*********************************************************************************************************
** : UART3_SendStr
** : ܺCH4383 һַ
** 䡡: ַ
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void CH438_UART3_SendStr( UINT8 *str )    
{

    while( 1 )
    {

        if( *str == '\0' ) break;

        CH438_UART3_SendByte( *str++ );

    }

}


/*********************************************************************************************************
** : CH438Seril3Send
** : ܺFIFOģʽ, CH4383 Ͷֽ
** 䡡: ݿ
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void  CH438Seril3Send( UINT8 *Data, UINT8 Num )
{
    do
    {

        while( ( ReadCH438Data( REG_LSR2_ADDR ) & BIT_LSR_THRE ) == 0 );    /* ȴݷ */

        WriteCH438Data( REG_THR3_ADDR, *Data++ );

    }

    while( --Num );

}



/*********************************************************************************************************
** : CH438Seril3Rcv
** : ܺFIFOģʽ, CH4383 նֽ
** 䡡: ݻַ
**
** 䡡: ݳ
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/

UINT8  CH438Seril3Rcv( UINT8 *buf )
{
    UINT8 RcvNum = 0;

    if( !( ReadCH438Data( REG_LSR3_ADDR ) & ( BIT_LSR_BREAKINT | BIT_LSR_FRAMEERR | BIT_LSR_PARERR | BIT_LSR_OVERR ) ) )    /* b1-b4޴ */
    {

        while( ( ReadCH438Data( REG_LSR3_ADDR ) & BIT_LSR_DATARDY ) == 0 );    /* ȴ׼ */

        do
        {

            *buf++ = ReadCH438Data( REG_RBR3_ADDR );                           /* ӽջĴ */

            RcvNum++;

        }

        while( ( ReadCH438Data( REG_LSR3_ADDR ) & BIT_LSR_DATARDY ) == 0x01 );
									   
    }

    else ReadCH438Data( REG_RBR3_ADDR );

    return( RcvNum );
}








/*********************************************************************************************************
** : CH438UART3Send
** : ܺFIFOģʽ, CH4383 Ͷֽ ෢128ֽ
** 䡡: ݻַ, ݿ鳤
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void  CH438UART3Send( UINT8 *Data, UINT8 Num )
{

    while( 1 )
    {

        while( ( ReadCH438Data( REG_LSR3_ADDR ) & BIT_LSR_TEMT ) == 0 );    /* ȴݷϣTHR,TSRȫ */

        if( Num <= 128 )
        {

            WriteCH438Block( REG_THR3_ADDR, Num, Data );

            break;

        }

        else
        {

            WriteCH438Block( REG_THR3_ADDR, 128, Data );

            Num -= 128;

            Data += 128;

        }

    }
}



/*********************************************************************************************************
** : Auto_HandFlow3_Ctrl
** : ܺ3ԶӲ
** 䡡: 
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void Auto_HandFlow3_Ctrl( void )
{

    WriteCH438Data( REG_MCR3_ADDR, BIT_MCR_AFE | BIT_MCR_OUT2 | BIT_MCR_RTS );    /* MCRĴAFERTSΪ1 */

}


