/******************************************************************************************/

/* оƬ */
/* CH4380Ĵַ */

#define REG_RBR_ADDR        0x00      /* 0ջĴַ */
#define REG_THR_ADDR        0x00      /* 0ͱּĴַ */
#define REG_IER_ADDR        0x01      /* 0жʹܼĴַ */
#define REG_IIR_ADDR        0x02      /* 0жʶĴַ */
#define REG_FCR_ADDR        0x02      /* 0FIFOƼĴַ */
#define REG_LCR_ADDR        0x03      /* 0·ƼĴַ */
#define REG_MCR_ADDR        0x04      /* 0MODEMƼĴַ */
#define REG_LSR_ADDR        0x05      /* 0·״̬Ĵַ */
#define REG_MSR_ADDR        0x06      /* 0MODEM״̬Ĵַ */
#define REG_SCR_ADDR        0x07      /* 0ûɶĴַ */
#define REG_DLL_ADDR        0x00      /* ʳ8λֽڵַ */
#define REG_DLM_ADDR        0x01      /* ʳ8λֽڵַ */

/* CH4381Ĵַ */

#define REG_RBR1_ADDR       0x10      /* ??1????????? */
#define REG_THR1_ADDR       0x10      /* ??1????????? */
#define REG_IER1_ADDR       0x11      /* ??1????????? */
#define REG_IIR1_ADDR       0x12      /* ??1????????? */
#define REG_FCR1_ADDR       0x12      /* ??1FIFO??????? */
#define REG_LCR1_ADDR       0x13      /* ??1????????? */
#define REG_MCR1_ADDR       0x14      /* ??1MODEM??????? */
#define REG_LSR1_ADDR       0x15      /* ??1????????? */
#define REG_MSR1_ADDR       0x16      /* ??1MODEM??????? */
#define REG_SCR1_ADDR       0x17      /* ??1?????????? */
#define REG_DLL1_ADDR       0x10      /* ?????????8????? */
#define REG_DLM1_ADDR       0x11      /* ?????????8????? */


/* CH4382Ĵַ */

#define REG_RBR2_ADDR       0x20      /* 2ջĴַ */
#define REG_THR2_ADDR       0x20      /* 2ͱּĴַ */
#define REG_IER2_ADDR       0x21      /* 2жʹܼĴַ */
#define REG_IIR2_ADDR       0x22      /* 2жʶĴַ */
#define REG_FCR2_ADDR       0x22      /* 2FIFOƼĴַ */
#define REG_LCR2_ADDR       0x23      /* 2·ƼĴַ */
#define REG_MCR2_ADDR       0x24      /* 2MODEMƼĴַ */
#define REG_LSR2_ADDR       0x25      /* 2·״̬Ĵַ */
#define REG_MSR2_ADDR       0x26      /* 2MODEM״̬Ĵַ */
#define REG_SCR2_ADDR       0x27      /* 2ûɶĴַ */
#define REG_DLL2_ADDR       0x20      /* ʳ8λֽڵַ */
#define REG_DLM2_ADDR       0x21      /* ʳ8λֽڵַ */



/* CH4383Ĵַ */

#define REG_RBR3_ADDR       0x30      /* 3ջĴַ */
#define REG_THR3_ADDR       0x30      /* 3ͱּĴַ */
#define REG_IER3_ADDR       0x31      /* 3жʹܼĴַ */
#define REG_IIR3_ADDR       0x32      /* 3жʶĴַ */
#define REG_FCR3_ADDR       0x32      /* 3FIFOƼĴַ */
#define REG_LCR3_ADDR       0x33      /* 3·ƼĴַ */
#define REG_MCR3_ADDR       0x34      /* 3MODEMƼĴַ */
#define REG_LSR3_ADDR       0x35      /* 3·״̬Ĵַ */
#define REG_MSR3_ADDR       0x36      /* 3MODEM״̬Ĵַ */
#define REG_SCR3_ADDR       0x37      /* 3ûɶĴַ */
#define REG_DLL3_ADDR       0x30      /* ʳ8λֽڵַ */
#define REG_DLM3_ADDR       0x31      /* ʳ8λֽڵַ */


/* CH4384Ĵַ */

#define REG_RBR4_ADDR       0x08      /* 4ջĴַ */
#define REG_THR4_ADDR       0x08      /* 4ͱּĴַ */
#define REG_IER4_ADDR       0x09      /* 4жʹܼĴַ */
#define REG_IIR4_ADDR       0x0A      /* 4жʶĴַ */
#define REG_FCR4_ADDR       0x0A      /* 4FIFOƼĴַ */
#define REG_LCR4_ADDR       0x0B      /* 4·ƼĴַ */
#define REG_MCR4_ADDR       0x0C      /* 4MODEMƼĴַ */
#define REG_LSR4_ADDR       0x0D      /* 4·״̬Ĵַ */
#define REG_MSR4_ADDR       0x0E      /* 4MODEM״̬Ĵַ */
#define REG_SCR4_ADDR       0x0F      /* 4ûɶĴַ */
#define REG_DLL4_ADDR       0x08      /* ʳ8λֽڵַ */
#define REG_DLM4_ADDR       0x09      /* ʳ8λֽڵַ */



/* CH4385Ĵַ */

#define REG_RBR5_ADDR       0x18      /* 5ջĴַ */
#define REG_THR5_ADDR       0x18      /* 5ͱּĴַ */
#define REG_IER5_ADDR       0x19      /* 5жʹܼĴַ */
#define REG_IIR5_ADDR       0x1A      /* 5жʶĴַ */
#define REG_FCR5_ADDR       0x1A      /* 5FIFOƼĴַ */
#define REG_LCR5_ADDR       0x1B      /* 5·ƼĴַ */
#define REG_MCR5_ADDR       0x1C      /* 5MODEMƼĴַ */
#define REG_LSR5_ADDR       0x1D      /* 5·״̬Ĵַ */
#define REG_MSR5_ADDR       0x1E      /* 5MODEM״̬Ĵַ */
#define REG_SCR5_ADDR       0x1F      /* 5ûɶĴַ */
#define REG_DLL5_ADDR       0x18      /* ʳ8λֽڵַ */
#define REG_DLM5_ADDR       0x19      /* ʳ8λֽڵַ */


/* CH4386Ĵַ */

#define REG_RBR6_ADDR       0x28      /* 6ջĴַ */
#define REG_THR6_ADDR       0x28      /* 6ͱּĴַ */
#define REG_IER6_ADDR       0x29      /* 6жʹܼĴַ */
#define REG_IIR6_ADDR       0x2A      /* 6жʶĴַ */
#define REG_FCR6_ADDR       0x2A      /* 6FIFOƼĴַ */
#define REG_LCR6_ADDR       0x2B      /* 6·ƼĴַ */
#define REG_MCR6_ADDR       0x2C      /* 6MODEMƼĴַ */
#define REG_LSR6_ADDR       0x2D      /* 6·״̬Ĵַ */
#define REG_MSR6_ADDR       0x2E      /* 6MODEM״̬Ĵַ */
#define REG_SCR6_ADDR       0x2F      /* 6ûɶĴַ */
#define REG_DLL6_ADDR       0x28      /* ʳ8λֽڵַ */
#define REG_DLM6_ADDR       0x29      /* ʳ8λֽڵַ */


/* CH4387Ĵַ */

#define REG_RBR7_ADDR       0x38      /* 7ջĴַ */
#define REG_THR7_ADDR       0x38      /* 7ͱּĴַ */
#define REG_IER7_ADDR       0x39      /* 7жʹܼĴַ */
#define REG_IIR7_ADDR       0x3A      /* 7жʶĴַ */
#define REG_FCR7_ADDR       0x3A      /* 7FIFOƼĴַ */
#define REG_LCR7_ADDR       0x3B      /* 7·ƼĴַ */
#define REG_MCR7_ADDR       0x3C      /* 7MODEMƼĴַ */
#define REG_LSR7_ADDR       0x3D      /* 7·״̬Ĵַ */
#define REG_MSR7_ADDR       0x3E      /* 7MODEM״̬Ĵַ */
#define REG_SCR7_ADDR       0x3F      /* 7ûɶĴַ */
#define REG_DLL7_ADDR       0x38      /* ʳ8λֽڵַ */
#define REG_DLM7_ADDR       0x39      /* ʳ8λֽڵַ */



/* CH438ڲ0~7 ר״̬Ĵ */
#define REG_SSR_ADDR        0x4F       /* ר״̬Ĵַ */


/* IERĴλ */

#define BIT_IER_RESET       0x80      /* λ1λô */
#define BIT_IER_LOWPOWER    0x40      /* λΪ1رոôڵڲ׼ʱ */
#define BIT_IER_SLP         0x20      /* 0SLP,Ϊ1رʱ */
#define BIT_IER1_CK2X       0x20      /* 1CK2X,Ϊ1ǿƽⲿʱź2ƵΪڲ׼ʱ */
#define BIT_IER_IEMODEM     0x08      /* λΪ1MODEM״̬仯ж */
#define BIT_IER_IELINES     0x04      /* λΪ1·״̬ж */
#define BIT_IER_IETHRE      0x02      /* λΪ1ͱּĴж */
#define BIT_IER_IERECV      0x01      /* λΪ1յж */

/* IIRĴλ */

#define BIT_IIR_FIFOENS1    0x80
#define BIT_IIR_FIFOENS0    0x40      /* 2λΪ1ʾFIFO */

/* жͣ0001ûжϣ0110·״̬жϣ0100ݿжϣ
1100ݳʱжϣ0010THRĴжϣ0000MODEM仯ж */
#define BIT_IIR_IID3        0x08
#define BIT_IIR_IID2        0x04
#define BIT_IIR_IID1        0x02
#define BIT_IIR_NOINT       0x01

/* FCRĴλ */

/* 㣺 00Ӧ1ֽڣ01Ӧ16ֽڣ10Ӧ64ֽڣ11Ӧ112ֽ */
#define BIT_FCR_RECVTG1     0x80      /* FIFOжϺԶӲƵĴ */
#define BIT_FCR_RECVTG0     0x40      /* FIFOжϺԶӲƵĴ */

#define BIT_FCR_TFIFORST    0x04      /* λ1շFIFOе */
#define BIT_FCR_RFIFORST    0x02      /* λ1սFIFOе */
#define BIT_FCR_FIFOEN      0x01      /* λ1FIFO,Ϊ0FIFO */

/* LCRĴλ */

#define BIT_LCR_DLAB        0x80      /* Ϊ1ܴȡDLLDLMΪ0ܴȡRBR/THR/IER */
#define BIT_LCR_BREAKEN     0x40      /* Ϊ1ǿƲBREAK·*/

/* УʽPARENΪ1ʱ00У飬01żУ飬10־λMARK1)11հλSPACE0) */
#define BIT_LCR_PARMODE1    0x20      /* żУλʽ */
#define BIT_LCR_PARMODE0    0x10      /* żУλʽ */

#define BIT_LCR_PAREN       0x08      /* Ϊ1ʱͽУżУλ */
#define BIT_LCR_STOPBIT     0x04      /* Ϊ1ֹͣλ,Ϊ0һֹͣλ */

/* ֳȣ005λ016λ107λ118λ */
#define BIT_LCR_WORDSZ1     0x02      /* ֳ */
#define BIT_LCR_WORDSZ0     0x01

/* MCRĴλ */

#define BIT_MCR_AFE         0x20      /* Ϊ1CTSRTSӲԶ */
#define BIT_MCR_LOOP        0x10      /* Ϊ1ʹڲ·Ĳģʽ */
#define BIT_MCR_OUT2        0x08      /* Ϊ1ôڵж */
#define BIT_MCR_OUT1        0x04      /* ΪûMODEMλ */
#define BIT_MCR_RTS         0x02      /* λΪ1RTSЧ */
#define BIT_MCR_DTR         0x01      /* λΪ1DTRЧ */

/* LSRĴλ */

#define BIT_LSR_RFIFOERR    0x80      /* Ϊ1ʾڽFIFOдһ */
#define BIT_LSR_TEMT        0x40      /* Ϊ1ʾTHRTSRȫ */
#define BIT_LSR_THRE        0x20      /* Ϊ1ʾTHR*/
#define BIT_LSR_BREAKINT    0x10      /* λΪ1ʾ⵽BREAK· */
#define BIT_LSR_FRAMEERR    0x08      /* λΪ1ʾȡ֡ */
#define BIT_LSR_PARERR      0x04      /* λΪ1ʾżУ */
#define BIT_LSR_OVERR       0x02      /* Ϊ1ʾFIFO */
#define BIT_LSR_DATARDY     0x01      /* λΪ1ʾFIFOнյ */

/* MSRĴλ */

#define BIT_MSR_DCD         0x80      /* λΪ1ʾDCDЧ */
#define BIT_MSR_RI          0x40      /* λΪ1ʾRIЧ */
#define BIT_MSR_DSR         0x20      /* λΪ1ʾDSRЧ */
#define BIT_MSR_CTS         0x10      /* λΪ1ʾCTSЧ */
#define BIT_MSR_DDCD        0x08      /* λΪ1ʾDCD״̬仯 */
#define BIT_MSR_TERI        0x04      /* λΪ1ʾRI״̬仯 */
#define BIT_MSR_DDSR        0x02      /* λΪ1ʾDSR״̬仯 */
#define BIT_MSR_DCTS        0x01      /* λΪ1ʾCTS״̬仯 */

/* ж״̬ */

#define INT_NOINT           0x01      /* ûж */
#define INT_THR_EMPTY       0x02      /* THRж */
#define INT_RCV_OVERTIME    0x0C      /* ճʱж */
#define INT_RCV_SUCCESS     0x04      /* ݿж */
#define INT_RCV_LINES       0x06      /* ·״̬ж */
#define INT_MODEM_CHANGE    0x00      /* MODEM仯ж */

#define CH438_IIR_FIFOS_ENABLED 0xC0  /* FIFO */

/*ֳֹͣλУλ
WriteCH438Data( CH438_LCR_PORT, BIT_LCR_WORDSZ1 
                              | BIT_LCR_WORDSZ0 );      // 0x03,ֳ8λ1λֹͣλ,żУ

WriteCH438Data( CH438_LCR_PORT, BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ1 
                              | BIT_LCR_WORDSZ0 );      // 0x0F,ֳ8λ2λֹͣλ,У

WriteCH438Data( CH438_LCR_PORT, BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ1 );      // 0x0E,ֳ7λ2λֹͣλУ


WriteCH438Data( CH438_LCR_PORT, BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ0 );      // 0x0D,ֳ6λ2λֹͣλУ


WriteCH438Data( CH438_LCR_PORT, BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT );      // 0x0C,ֳ5λ2λֹͣλУ


WriteCH438Data( CH438_LCR_PORT, BIT_LCR_PARMODE0 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ1 
                              | BIT_LCR_WORDSZ0 );      // 0x1F,ֳ8λ2λֹͣλżУ

WriteCH438Data( CH438_LCR_PORT, BIT_LCR_PARMODE0 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ1 );      // 0x1E,ֳ7λ2λֹͣλżУ

WriteCH438Data( CH438_LCR_PORT, BIT_LCR_PARMODE0 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ0 );      // 0x1D,ֳ6λ2λֹͣλżУ

WriteCH438Data( CH438_LCR_PORT, BIT_LCR_PARMODE0 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT );      // 0x1C,ֳ5λ2λֹͣλżУ

WriteCH438Data( CH438_LCR_PORT, BIT_LCR_PARMODE1 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ1 
                              | BIT_LCR_WORDSZ0 );      // 0x2F,ֳ8λ2λֹͣλ־1У

WriteCH438Data( CH438_LCR_PORT, BIT_LCR_PARMODE1 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ1 );      // 0x2E,ֳ7λ2λֹͣλ־1У

WriteCH438Data( CH438_LCR_PORT, BIT_LCR_PARMODE1 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ0 );      // 0x2D,ֳ6λ2λֹͣλ־1У

WriteCH438Data( CH438_LCR_PORT, BIT_LCR_PARMODE1 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT );      // 0x2C,ֳ5λ2λֹͣλ־1У

WriteCH438Data( CH438_LCR_PORT, BIT_LCR_PARMODE1 
                              | BIT_LCR_PARMODE0
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ1 
                              | BIT_LCR_WORDSZ0 );      // 0x3F,ֳ8λ2λֹͣλհ0У

WriteCH438Data( CH438_LCR_PORT, BIT_LCR_PARMODE1 
                              | BIT_LCR_PARMODE0
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ1 );      // 0x3E,ֳ7λ2λֹͣλհ0У

WriteCH438Data( CH438_LCR_PORT, BIT_LCR_PARMODE1
                              | BIT_LCR_PARMODE0
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ0 );      // 0x3D,ֳ6λ2λֹͣλհ0У

WriteCH438Data( CH438_LCR_PORT, BIT_LCR_PARMODE1
                              | BIT_LCR_PARMODE0
                              | BIT_LCR_PAREN 
                              | BIT_LCR_STOPBIT );      // 0x3C,ֳ5λ2λֹͣλհ0У

WriteCH438Data( CH438_LCR_PORT, BIT_LCR_PARMODE0 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_WORDSZ1 
                              | BIT_LCR_WORDSZ0 );      // 0x1B,ֳ8λ1λֹͣλżУ

WriteCH438Data( CH438_LCR_PORT, BIT_LCR_PARMODE0 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_WORDSZ1 );      // 0x1A,ֳ7λ1λֹͣλżУ


WriteCH438Data( CH438_LCR_PORT, BIT_LCR_PARMODE0 
                              | BIT_LCR_PAREN 
                              | BIT_LCR_WORDSZ0 );      // 0x19,ֳ6λ1λֹͣλżУ

WriteCH438Data( CH438_LCR_PORT, BIT_LCR_PARMODE0 
                              | BIT_LCR_PAREN );      // 0x18,ֳ5λ1λֹͣλżУ

WriteCH438Data( CH438_LCR_PORT, BIT_LCR_STOPBIT 
                              | BIT_LCR_WORDSZ1 
                              | BIT_LCR_WORDSZ0 );      // 0x07,ֳ8λ2λֹͣλ,żУ
*/

