/* 2011.8.26
****************************************
**  Copyright  (C)        1999-2011   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/

/*
********************************************** 
**
**  ʼCH438 0 
**
**********************************************
*/

#include "include.h"

/*
  ĬϵⲿʱƵ22.1184MHZ
*/
#define CH438UART0_BPS  9600           /* CH4380ͨѶ */
#define Fpclk           1843200         /* ڲʱƵ    */


/*********************************************************************************************************
** : InitCH438UART0
** : ãڳʼCH4380
** 䡡: 
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/

void InitCH438UART0( void )       
{
    UINT16 div;
    UINT8 DLL, DLM;

/**************************************************************************
          CH4380ļĴ
**************************************************************************/
    div = ( Fpclk >> 4 ) / CH438UART0_BPS;
    DLM = div >> 8;
    DLL = div & 0xff;
    WriteCH438Data( REG_LCR_ADDR, BIT_LCR_DLAB );    /* DLABΪ1 */
    
	WriteCH438Data( REG_DLL_ADDR, DLL );             /* ò */
	WriteCH438Data( REG_DLM_ADDR, DLM );
		
    WriteCH438Data( REG_FCR_ADDR, BIT_FCR_RECVTG1 | BIT_FCR_RECVTG0 | BIT_FCR_FIFOEN );    /* FIFOģʽΪ112ֽ */
	WriteCH438Data( REG_LCR_ADDR, BIT_LCR_WORDSZ1 | BIT_LCR_WORDSZ0 ); 
    WriteCH438Data( REG_IER_ADDR, /*BIT_IER_IEMODEM | */BIT_IER_IELINES | BIT_IER_IETHRE | BIT_IER_IERECV );    /* ʹж */
    WriteCH438Data( REG_MCR_ADDR, BIT_MCR_OUT2    | BIT_MCR_RTS     | BIT_MCR_DTR );              /* ж,DTR,RTSΪ1 */   // WriteCH438Data(REG_FCR_ADDR,ReadCH438Data(REG_FCR_ADDR)| BIT_FCR_TFIFORST|BIT_FCR_RFIFORST);  /* FIFOе */
	//WriteCH438Data(REG_FCR_ADDR,ReadCH438Data(REG_FCR1_ADDR)| BIT_FCR_TFIFORST|BIT_FCR_RFIFORST);
}



/*********************************************************************************************************
** : UART0_Reset
** : ܺڸλCH4380, λ֮Ҫ³ʼ ſʹ
** 䡡: 
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void CH438_UART0_Reset( void )
{

    WriteCH438Data( REG_IER_ADDR, BIT_IER_RESET ); 

}




/*********************************************************************************************************
** : UART0_LowPower
** : ܺCH4380͹ģʽ
** 䡡: 
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void CH438_UART0_LowPower( void )
{

    WriteCH438Data( REG_IER_ADDR, BIT_IER_LOWPOWER ); 

}




/*********************************************************************************************************
** : CH438_LowPower
** : ܺCH438еĴڽ͹ģʽ
** 䡡: 
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void CH438_LowPower( void )
{

    WriteCH438Data( REG_IER_ADDR, BIT_IER_SLP ); 

}


/*********************************************************************************************************
** : UART0_SendByte
** : ܺCH4380 ͵ֽ
** 䡡: 
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void CH438_UART0_SendByte( UINT8 dat )    
{

    while( ( ReadCH438Data( REG_LSR_ADDR ) & BIT_LSR_THRE ) == 0 );    /* ȴݷ */

    WriteCH438Data( REG_THR_ADDR, dat );
}




/*********************************************************************************************************
** : UART0_RcvByte
** : ܺCH4380 յֽ
** 䡡: 
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
UINT8 CH438_UART0_RcvByte( void )    
{

    UINT8 Rcvdat;

    if( !( ReadCH438Data( REG_LSR_ADDR ) & ( BIT_LSR_BREAKINT | BIT_LSR_FRAMEERR | BIT_LSR_PARERR | BIT_LSR_OVERR ) ) )    /*  b1-b4޴ */
    {

        while( ( ReadCH438Data( REG_LSR_ADDR ) & BIT_LSR_DATARDY ) == 0 );    /* ȴ׼ */

        Rcvdat = ReadCH438Data( REG_RBR_ADDR );    /* ӽջĴ */

        return( Rcvdat );
    }

    else ReadCH438Data( REG_RBR_ADDR );    /* д */

}





/*********************************************************************************************************
** : UART0_SendStr
** : ܺCH4380 һַ
** 䡡: ַ
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void CH438_UART0_SendStr( UINT8 *str )    
{

    while( 1 )
    {

        if( *str == '\0' ) break;

        CH438_UART0_SendByte( *str++ );

    }

}


/*********************************************************************************************************
** : CH438Seril0Send
** : ܺFIFOģʽ, CH4380 Ͷֽ
** 䡡: ݿ
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void  CH438Seril0Send( UINT8 *Data, UINT8 Num )
{
    do
    {

        while( ( ReadCH438Data( REG_LSR_ADDR ) & BIT_LSR_THRE ) == 0 );    /* ȴݷ */

        WriteCH438Data( REG_THR_ADDR, *Data++ );

    }

    while( --Num );

}



/*********************************************************************************************************
** : CH438Seril0Rcv
** : ܺFIFOģʽ, CH4380 նֽ
** 䡡: ݻַ
**
** 䡡: ݳ
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/

UINT8  CH438Seril0Rcv( UINT8 *buf )
{
    UINT8 RcvNum = 0;

    if( !( ReadCH438Data( REG_LSR_ADDR ) & ( BIT_LSR_BREAKINT | BIT_LSR_FRAMEERR | BIT_LSR_PARERR | BIT_LSR_OVERR ) ) )    /* b1-b4޴ */
    {

        while( ( ReadCH438Data( REG_LSR_ADDR ) & BIT_LSR_DATARDY ) == 0 );    /* ȴ׼ */

        do
        {

            *buf++ = ReadCH438Data( REG_RBR_ADDR );                           /* ӽջĴ */

            RcvNum++;

        }

        while( ( ReadCH438Data( REG_LSR_ADDR ) & BIT_LSR_DATARDY ) == 0x01 );

    }

    else ReadCH438Data( REG_RBR_ADDR );

    return( RcvNum );
}








/*********************************************************************************************************
** : CH438UART0Send
** : ܺFIFOģʽ, CH4380 Ͷֽ ෢128ֽ
** 䡡: ݻַ, ݿ鳤
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void  CH438UART0Send( UINT8 *Data, UINT8 Num )
{

    while( 1 )
    {

        while( ( ReadCH438Data( REG_LSR_ADDR ) & BIT_LSR_TEMT ) == 0 );    /* ȴݷϣTHR,TSRȫ */

        if( Num <= 128 )
        {

            WriteCH438Block( REG_THR_ADDR, Num, Data );

            break;

        }

        else
        {

            WriteCH438Block( REG_THR_ADDR, 128, Data );

            Num -= 128;

            Data += 128;

        }

    }
}



/*********************************************************************************************************
** : Auto_HandFlow0_Ctrl
** : ܺ0ԶӲ
** 䡡: 
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void Auto_HandFlow0_Ctrl( void )
{

    WriteCH438Data( REG_MCR_ADDR, BIT_MCR_AFE | BIT_MCR_OUT2 | BIT_MCR_RTS );    /* MCRĴAFERTSΪ1 */

}

