 
#include "include.h"
 
unsigned char buf[128];
UINT8 UART0_STRING[ ] = {" I am UART0 \n" };
UINT8 UART1_STRING[ ] = {" I am UART1 \n" };
UINT8 UART2_STRING[ ] = {" I am UART2 \n" };
UINT8 UART3_STRING[ ] = {" I am UART3 \n" };
UINT8 UART4_STRING[ ] = {" I am UART4 \n" };
UINT8 UART5_STRING[ ] = {" I am UART5 \n" };
UINT8 UART6_STRING[ ] = {" I am UART6 \n" };
UINT8 UART7_STRING[ ] = {" I am UART7 \n" };
 
 int main(void)
 {	 
	u8 key,numb;		 
 	u8 i=0;	     
	u32 ts=0;
	delay_init();	    	 //ʱʼ	  
	 
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);//жȼΪ22λռȼ2λӦȼ
	uart_init(115200);	 	//ڳʼΪ115200
	printf("CH438 Test\n");
 
 	FSMC_SRAM_Init();			//ʼⲿSRAM  
	INT_Init();
	 
    InitCH438UART0( );
    InitCH438UART1( );
    InitCH438UART2( );
    InitCH438UART3( );
    InitCH438UART4( );
    InitCH438UART5( );
    InitCH438UART6( );
    InitCH438UART7( );
    CH438_UART4_SendStr(UART4_STRING);
  	while(1)
	{	
	}	      
}

void EXTI15_10_IRQHandler(void)
{
	UINT8 gInterruptStatus;		/* ȫж״̬ */
    UINT8 InterruptStatus;		/* ж״̬ */
    UINT8 RcvNum = 0, s;
    UINT8 ModemStatus;
	
	gInterruptStatus = ReadCH438Data( REG_SSR_ADDR );
    printf("IF:%02x\n",gInterruptStatus);

    if( gInterruptStatus & 0x01  )    /* ⴮0Ƿжϲ */
    {
        InterruptStatus = ReadCH438Data( REG_IIR_ADDR ) & ( ~ CH438_IIR_FIFOS_ENABLED );    /* 0ж״̬ */
        printf("INT0:%02x\n",InterruptStatus);
		if( ( InterruptStatus & 0x01 ) ) return;    /* ûж˳ */
        else
        {
            switch( InterruptStatus )
            {
            case INT_NOINT:    /* ûж */
                break;
            case INT_THR_EMPTY:    /* ͱּĴж */
//                    UART0_SendStr( "UART0 THR Empty \n" );
                break;
            case INT_RCV_SUCCESS:    /* ڽտж */
				ReadCH438Data( REG_RBR_ADDR );
                RcvNum = CH438Seril0Rcv( buf );
                CH438Seril0Send( buf, RcvNum );
                break;
            case INT_RCV_LINES:    /* ·״̬ж */
                ReadCH438Data( REG_LSR_ADDR);
                break;
            case INT_RCV_OVERTIME:    /* ݳʱж */
                RcvNum = CH438Seril0Rcv( buf );
                CH438Seril0Send( buf, RcvNum );
                break;
            case INT_MODEM_CHANGE:
                ModemStatus = ReadCH438Data( REG_MSR_ADDR );
                CH438_UART0_SendStr( " Modem Change \n" );
                if ( ModemStatus == 0x30 )        /* Modemźŷݱ仯 */
                {
//                       UART0_SendStr( "DSR CTS is Free \n" );
                }
                else if ( ModemStatus == 0x11 )    /* Modem źŽݱ仯 */
                {
//                      UART0_SendStr( "DSR CTS is Free \n" );
                }
                else if ( ModemStatus == 0x22 )    /* Modem źŽݱ仯 */
                {
                    s = ReadCH438Data( REG_RBR_ADDR );
//                       UART0_SendStr( "DSR has changed \n" );
                }
                break;

            default:    /* ܷж */
                break;
            }
        }
    }

	 if( gInterruptStatus & 0x02  )    /* ⴮1Ƿжϲ */
    {
        InterruptStatus = ReadCH438Data( REG_IIR1_ADDR ) & ( ~ CH438_IIR_FIFOS_ENABLED );    /* 1ж״̬ */
        printf("INT1:%02x\n",InterruptStatus);
		if( ( InterruptStatus & 0x01 ) ) return;    /* ûж˳ */
        else
        {
            switch( InterruptStatus )
             {
                case INT_NOINT:    /* ûж */
                     break;
                case INT_THR_EMPTY:    /* ͱּĴж */
//                    UART1_SendStr( "UART1 THR Empty \n" );
                    break;
                case INT_RCV_SUCCESS:    /* ڽտж */
                    RcvNum = CH438Seril1Rcv( buf );
                    CH438Seril1Send( buf, RcvNum );
                    break;
                case INT_RCV_LINES:    /* ·״̬ж */
                    ReadCH438Data( REG_LSR1_ADDR);
                    break;
                case INT_RCV_OVERTIME:    /* ݳʱж */
                    RcvNum = CH438Seril1Rcv( buf );
                    CH438Seril1Send( buf, RcvNum );
                    break;
	            case INT_MODEM_CHANGE:
                    ModemStatus = ReadCH438Data( REG_MSR1_ADDR );
                    CH438_UART1_SendStr( " Modem Change \n" );
                    if ( ModemStatus == 0x30 )        /* Modemźŷݱ仯 */
                     {
//                    UART1_SendStr( SEND_STRING1 );
                      }
                    else if ( ModemStatus == 0x11 )    /* Modem źŽݱ仯 */
                     {
//                    WriteCH438Data( CH438_THR1_PORT, 0xAA );
                      }
                    else if ( ModemStatus == 0x22 )    /* Modem źŽݱ仯 */
                     {
                       s = ReadCH438Data( REG_RBR1_ADDR );
//                     WriteCH438Data( CH438_THR1_PORT, s );
                       }
                     break;

                default:    /* ܷж */
                    break;
            }
        }
    }


	 if( gInterruptStatus & 0x04  )    /* ⴮2Ƿжϲ */
    {
        InterruptStatus = ReadCH438Data( REG_IIR2_ADDR ) & ( ~ CH438_IIR_FIFOS_ENABLED );    /* 2ж״̬ */
        printf("INT2:%02x\n",InterruptStatus);
		if( ( InterruptStatus & 0x01 ) ) return;    /* ûж˳ */
        else
        {
            switch( InterruptStatus )
             {
                case INT_NOINT:    /* ûж */
                     break;
                case INT_THR_EMPTY:    /* ͱּĴж */
//                    UART2_SendStr( "UART2 THR Empty \n" );
                    break;
                case INT_RCV_SUCCESS:    /* ڽտж */
                    RcvNum = CH438Seril2Rcv( buf );
                    CH438Seril2Send( buf, RcvNum );
                    break;
                case INT_RCV_LINES:    /* ·״̬ж */
                    ReadCH438Data( REG_LSR2_ADDR);
                    break;
                case INT_RCV_OVERTIME:    /* ݳʱж */
                    RcvNum = CH438Seril2Rcv( buf );
                    CH438Seril2Send( buf, RcvNum );
                    break;
	            case INT_MODEM_CHANGE:
                    ModemStatus = ReadCH438Data( REG_MSR2_ADDR );
                    CH438_UART2_SendStr( " Modem Change \n" );
                    if ( ModemStatus == 0x30 )        /* Modemźŷݱ仯 */
                     {
//                    UART2_SendStr( SEND_STRING1 );
                      }
                    else if ( ModemStatus == 0x11 )    /* Modem źŽݱ仯 */
                     {
//                    WriteCH438Data( CH438_THR2_PORT, 0xAA );
                      }
                    else if ( ModemStatus == 0x22 )    /* Modem źŽݱ仯 */
                     {
                       s = ReadCH438Data( REG_RBR2_ADDR );
//                     WriteCH438Data( CH438_THR2_PORT, s );
                       }
                     break;

                default:    /* ܷж */
                    break;
            }
        }
    }



	 if( gInterruptStatus & 0x08  )    /* ⴮3Ƿжϲ */
    {
        InterruptStatus = ReadCH438Data( REG_IIR3_ADDR ) & ( ~ CH438_IIR_FIFOS_ENABLED );    /* 3ж״̬ */
        printf("INT3:%02x\n",InterruptStatus);
		if( ( InterruptStatus & 0x01 ) ) return;    /* ûж˳ */
        else
        {
            switch( InterruptStatus )
             {
                case INT_NOINT:    /* ûж */
                     break;
                case INT_THR_EMPTY:    /* ͱּĴж */
//                    UART3_SendStr( "UART3 THR Empty \n" );
                    break;
                case INT_RCV_SUCCESS:    /* ڽտж */
                    RcvNum = CH438Seril3Rcv( buf );
                    CH438Seril3Send( buf, RcvNum );
                    break;
                case INT_RCV_LINES:    /* ·״̬ж */
                    ReadCH438Data( REG_LSR3_ADDR);
                    break;
                case INT_RCV_OVERTIME:    /* ݳʱж */
                    RcvNum = CH438Seril3Rcv( buf );
                    CH438Seril3Send( buf, RcvNum );
                    break;
	            case INT_MODEM_CHANGE:
                    ModemStatus = ReadCH438Data( REG_MSR3_ADDR );
                    CH438_UART3_SendStr( " Modem Change \n" );
                    if ( ModemStatus == 0x30 )        /* Modemźŷݱ仯 */
                     {
//                      UART3_SendStr( "DSR CTS is Free \n" );
                      }
                    else if ( ModemStatus == 0x11 )    /* Modem źŽݱ仯 */
                     {
//                      UART3_SendStr( " CTS has changed \n" );
                      }
                    else if ( ModemStatus == 0x22 )    /* Modem źŽݱ仯 */
                     {
                       s = ReadCH438Data( REG_RBR3_ADDR );
//                       UART3_SendStr( "DSR has changed \n" );
                       }
                     break;

                default:    /* ܷж */
                    break;
            }
        }
    }


	 if( gInterruptStatus & 0x10  )    /* ⴮4Ƿжϲ */
    {
        InterruptStatus = ReadCH438Data( REG_IIR4_ADDR ) & ( ~ CH438_IIR_FIFOS_ENABLED );    /* 4ж״̬ */
        printf("INT4:%02x\n",InterruptStatus);
		if( ( InterruptStatus & 0x01 ) ) return;    /* ûж˳ */
        else
        {
            switch( InterruptStatus )
             {
                case INT_NOINT:    /* ûж */
                     break;
                case INT_THR_EMPTY:    /* ͱּĴж */
//                    UART4_SendStr( "UART4 THR Empty \n" );
                    break;
                case INT_RCV_SUCCESS:    /* ڽտж */
                    RcvNum = CH438Seril4Rcv( buf );
                    CH438Seril4Send( buf, RcvNum );
                    break;
                case INT_RCV_LINES:    /* ·״̬ж */
                    ReadCH438Data( REG_LSR4_ADDR);
                    break;
                case INT_RCV_OVERTIME:    /* ݳʱж */
                    RcvNum = CH438Seril4Rcv( buf );
                    CH438Seril4Send( buf, RcvNum );
                    break;
	            case INT_MODEM_CHANGE:
                    ModemStatus = ReadCH438Data( REG_MSR4_ADDR );
                    CH438_UART4_SendStr( " Modem Change \n" );
                    if ( ModemStatus == 0x30 )        /* Modemźŷݱ仯 */
                     {
//                    CH438_UART0_SendStr( SEND_STRING1 );
                      }
                    else if ( ModemStatus == 0x11 )    /* Modem źŽݱ仯 */
                     {
//                    WriteCH438Data( CH438_THR_PORT, 0xAA );
                      }
                    else if ( ModemStatus == 0x22 )    /* Modem źŽݱ仯 */
                     {
                       s = ReadCH438Data( REG_RBR4_ADDR );
//                     WriteCH438Data( CH438_THR_PORT, s );
                       }
                     break;

                default:    /* ܷж */
                    break;
            }
        }
    }


	 if( gInterruptStatus & 0x20  )    /* ⴮5Ƿжϲ */
    {
        InterruptStatus = ReadCH438Data( REG_IIR5_ADDR ) & ( ~ CH438_IIR_FIFOS_ENABLED );    /* 5ж״̬ */
        printf("INT5:%02x\n",InterruptStatus);
		if( ( InterruptStatus & 0x01 ) ) return;    /* ûж˳ */
        else
        {
            switch( InterruptStatus )
             {
                case INT_NOINT:    /* ûж */
                     break;
                case INT_THR_EMPTY:    /* ͱּĴж */
//                    UART5_SendStr( "UART5 THR Empty \n" );
                    break;
                case INT_RCV_SUCCESS:    /* ڽտж */
                    RcvNum = CH438Seril5Rcv( buf );
                    CH438Seril5Send( buf, RcvNum );
                    break;
                case INT_RCV_LINES:    /* ·״̬ж */
                    ReadCH438Data( REG_LSR5_ADDR);
                    break;
                case INT_RCV_OVERTIME:    /* ݳʱж */
                    RcvNum = CH438Seril5Rcv( buf );
                    CH438Seril5Send( buf, RcvNum );
                    break;
	            case INT_MODEM_CHANGE:
                    ModemStatus = ReadCH438Data( REG_MSR5_ADDR );
                    CH438_UART5_SendStr( " Modem Change \n" );
                    if ( ModemStatus == 0x30 )        /* Modemźŷݱ仯 */
                     {
//                    CH438_UART0_SendStr( SEND_STRING1 );
                      }
                    else if ( ModemStatus == 0x11 )    /* Modem źŽݱ仯 */
                     {
//                    WriteCH438Data( CH438_THR_PORT, 0xAA );
                      }
                    else if ( ModemStatus == 0x22 )    /* Modem źŽݱ仯 */
                     {
                       s = ReadCH438Data( REG_RBR5_ADDR );
//                     WriteCH438Data( CH438_THR_PORT, s );
                       }
                     break;

                default:    /* ܷж */
                    break;
            }
        }
    }


	 if( gInterruptStatus & 0x40  )    /* ⴮6Ƿжϲ */
    {
        InterruptStatus = ReadCH438Data( REG_IIR6_ADDR ) & ( ~ CH438_IIR_FIFOS_ENABLED );    /* 6ж״̬ */
        printf("INT6:%02x\n",InterruptStatus);
		if( ( InterruptStatus & 0x01 ) ) return;    /* ûж˳ */
        else
        {
            switch( InterruptStatus )
             {
                case INT_NOINT:    /* ûж */
                     break;
                case INT_THR_EMPTY:    /* ͱּĴж */
//                    UART6_SendStr( "UART6 THR Empty \n" );
                    break;
                case INT_RCV_SUCCESS:    /* ڽտж */
                    RcvNum = CH438Seril6Rcv( buf );
                    CH438Seril6Send( buf, RcvNum );
                    break;
                case INT_RCV_LINES:    /* ·״̬ж */
                    ReadCH438Data( REG_LSR6_ADDR);
                    break;
                case INT_RCV_OVERTIME:    /* ݳʱж */
                    RcvNum = CH438Seril6Rcv( buf );
                    CH438Seril6Send( buf, RcvNum );
                    break;
	            case INT_MODEM_CHANGE:
                    ModemStatus = ReadCH438Data( REG_MSR6_ADDR );
                    CH438_UART6_SendStr( " Modem Change \n" );
                    if ( ModemStatus == 0x30 )        /* Modemźŷݱ仯 */
                     {
//                    UART0_SendStr( SEND_STRING1 );
                      }
                    else if ( ModemStatus == 0x11 )    /* Modem źŽݱ仯 */
                     {
//                    WriteCH438Data( CH438_THR_PORT, 0xAA );
                      }
                    else if ( ModemStatus == 0x22 )    /* Modem źŽݱ仯 */
                     {
                       s = ReadCH438Data( REG_RBR6_ADDR );
//                     WriteCH438Data( CH438_THR_PORT, s );
                       }
                     break;

                default:    /* ܷж */
                    break;
            }
        }
    }



	 if( gInterruptStatus & 0x80  )    /* ⴮7Ƿжϲ */
    {
        InterruptStatus = ReadCH438Data( REG_IIR7_ADDR ) & ( ~ CH438_IIR_FIFOS_ENABLED );    /* 7ж״̬ */
        printf("INT7:%02x\n",InterruptStatus);
		if( ( InterruptStatus & 0x01 ) ) return;    /* ûж˳ */
        else
        {
            switch( InterruptStatus )
             {
                case INT_NOINT:    /* ûж */
                     break;
                case INT_THR_EMPTY:    /* ͱּĴж */
//                    UART7_SendStr( "UART7 THR Empty \n" );
                    break;
                case INT_RCV_SUCCESS:    /* ڽտж */
                    RcvNum = CH438Seril7Rcv( buf );
                    CH438Seril7Send( buf, RcvNum );
                    break;
                case INT_RCV_LINES:    /* ·״̬ж */
                    ReadCH438Data( REG_LSR7_ADDR);
                    break;
                case INT_RCV_OVERTIME:    /* ݳʱж */
                    RcvNum = CH438Seril7Rcv( buf );
                    CH438Seril7Send( buf, RcvNum );
                    break;
	            case INT_MODEM_CHANGE:
                    ModemStatus = ReadCH438Data( REG_MSR7_ADDR );
                    CH438_UART7_SendStr( " Modem Change \n" );
                    if ( ModemStatus == 0x30 )        /* Modemźŷݱ仯 */
                     {
//                    UART0_SendStr( SEND_STRING1 );
                      }
                    else if ( ModemStatus == 0x11 )    /* Modem źŽݱ仯 */
                     {
//                    WriteCH438Data( CH438_THR_PORT, 0xAA );
                      }
                    else if ( ModemStatus == 0x22 )    /* Modem źŽݱ仯 */
                     {
                       s = ReadCH438Data( REG_RBR7_ADDR );
//                     WriteCH438Data( CH438_THR_PORT, s );
                       }
                     break;

                default:    /* ܷж */
                    break;
            }
        }
    }
	else { }
    EXTI_ClearITPendingBit(EXTI_Line10); //жϱ־λֹж
}

